package com.flashdynamix.effects {

	/**
	 * @author flashdynamix
	 */
	import flash.utils.getTimer;	

	public class TweenItem {
		
		private var timer:Number;
		public var instance:*;
		public var args:Array;
		public var duration:Number;
		public var ease:Function;
		public var delay:Number;
		public var data:*;
		
		public function TweenItem(instance:*, target:Object, duration:Number, ease:Function, delay:Number = 0, data:* = null){
			timer = getTimer();
			this.instance = instance;
			this.target = target;
			this.duration = duration*1000;
			this.ease = ease;
			this.delay = delay*1000;
			this.data = data;
		}
		public function update():void{
			var i:int = 0;
			while(i<args.length){
				var tp:TweenProperty = args[i];
				tp.update(ease, played, duration);
				i++;
			}
		}
		public function get isPlaying():Boolean{
			return (started && !finished);
		}
		public function get played():Number{
			return Math.min(duration, Math.max(0,  getTimer()-timer-delay ));
		}
		public function get started():Boolean {
			return (played>0);
		}
		public function get finished():Boolean {
			return (played==duration);
		}
		public function set target(v:Object):void{
			args = new Array();
			for(var prop:String in v){
				args.push(new TweenProperty(instance, prop, v[prop]));
			}
		}
	}
}

class TweenProperty {
	
	public var instance:*;
	public var prop:String;
	public var initial:Number;
	public var target:Number;
	public var change:Number;
	public var duration:Number;
	public var _value:Number;
	
	public function TweenProperty(instance:*, prop:String, target:Number){
		this.instance = instance;
		this.prop = prop;
		this.target = target;
	}
	public function update(ease:Function, played:Number, duration:Number):void{
		if(isNaN(initial)){
			_value = initial = value;
			change = target-initial;
		}
		if(played == duration){
			value = target;
		} else {
			var args:Array = (ease.length == 2)?[target, _value]:[played, initial, change, duration];
			value = ease.apply(this, args);
		}
	}
	public function set value(num:Number):void{
		if(prop == "currentFrame"){
			instance.gotoAndStop(Math.round(num));
		} else {
			instance[prop] = num;
		}
		_value = num;
	}
	public function get value():Number{
		return instance[prop];
	}
}
