﻿package com.flashdynamix.services {

	/**
	 * @author flashdynamix
	 */

	public class YouTubeData {

		private static var media : Namespace;
		private static var openSearch : Namespace;
		private static var yt : Namespace;
		private static var gd : Namespace;

		private static const GD_TAG : String = "gd";
		private static const YT_TAG : String = "yt";
		private static const MEDIA_TAG : String = "media";
		private static const OPEN_SEARCH_TAG : String = "openSearch";

		public static function profile(xml : XML) : Object {
			yt = xml.namespace(YT_TAG);
			media = xml.namespace(MEDIA_TAG);
			
			var data : Object = new Object();
			data.firstName = xml.yt::firstName;
			data.lastName = xml.yt::lastName;
			data.username = xml.yt::username;
			data.company = xml.yt::company;
			data.location = xml.yt::location;
			data.thumbnail = xml.media::thumbnail.@url;
			data.viewCount = xml.yt::statistics.@viewCount;
			data.subscriberCount = xml.yt::statistics.@subscriberCount;
			
			return data;
		}

		public static function video(list : XML) : Object {
			
			var item : Object = new Object();
			item.title = list.media::title;
			item.link = list.media::player.@url;
			item.description = list.media::description;
			item.duration = list.yt::duration.@seconds;
			item.img = list.media::thumbnail[0].@url;
			item.category = list.media::category.@label;
			item.keywords = list.media::keywords;
			
			return item;
		}

		public static function videos(xml : XML, list : XMLList) : Object {
			yt = xml.namespace(YT_TAG);
			media = xml.namespace(MEDIA_TAG);
			openSearch = xml.namespace(OPEN_SEARCH_TAG);
			gd = xml.namespace(GD_TAG);
			
			var response : Object = new Object();
			response.totalResults = xml.channel.openSearch::totalResults;
			response.startIndex = xml.channel.openSearch::startIndex;
			
			var data : Array = response.items = new Array();
			for(var i : int = 0;i < list.length(); i++) {
				data.push(video(list[i]));
			}
			
			return response;
		}

		public static function subscription(xml : XML, list : XMLList) : Array {
			yt = xml.namespace(YT_TAG);
			gd = xml.namespace(GD_TAG);
			var data : Array = new Array();
			
			for(var i : int = 0;i < list.length(); i++) {
				
				var item : Object = new Object();
				item.username = list[i].yt::username;
				item.href = list[i].gd::feedLink.@href;
				item.countHint = list[i].gd::feedLink.@countHint;
				
				if(item.username.toString() != "") {
					data.push(item);
				}
			}
			
			return data;
		}

		public static function playlist(xml : XML, list : XMLList) : Object {
			yt = xml.namespace(YT_TAG);
			media = xml.namespace(MEDIA_TAG);
			gd = xml.namespace(GD_TAG);
			openSearch = xml.namespace(OPEN_SEARCH_TAG);
			
			var response : Object = new Object();
			response.totalResults = xml.channel.openSearch::totalResults;
			response.startIndex = xml.channel.openSearch::startIndex;
			
			var data : Array = response.items = new Array();
			for(var i : int = 0;i < list.length(); i++) {
				
				var item : Object = new Object();
				item.description = list[i].yt::description;
				item.feedLink = list[i].gd::feedLink.@href;
				item.countHint = list[i].gd::feedLink.@countHint;
				
				if(item.description.toString() != "") {
					data.push(item);
				}
			}
			
			return response;
		}

		public static function contacts(xml : XML, list : XMLList) : Array {
			yt = xml.namespace(YT_TAG);
			var data : Array = new Array();
			
			for(var i : int = 0;i < list.length(); i++) {

				var item : Object = new Object();
				item.username = list[i].yt::username;
				item.status = list[i].yt::status;
				
				if(item.username.toString() != "") {
					data.push(item);
				}
			}
			
			return data;
		}
	}
}
