package com.flashdynamix.utils {
	public class NumberUtil {
		
		public static const CURRENCY:String = "$";
		
		public static function time(t:Number):Object{
			
			var secs:String = uint(t%60).toString();
			secs = (secs.length == 1)?"0"+secs:secs;
			var mins:String = uint(t/60).toString();
			mins = (mins.length == 1)?"0"+mins:mins;
			
			return {mins:mins, secs:secs, time:mins+":"+secs};
		}
		public static function randomInt(start:int, end:int):int{
			return start+ Math.round(Math.random()*(end-start));
		}
		public static function money(n:Number):String{
			var whole:Number = Math.floor(n);
			var dec:Number = (n-whole)*100;
			var decFloor:Number = Math.floor(dec/5)*5;
			dec = ((dec%5) > 2) ? decFloor+5:decFloor;
			var nStr:String = NumberUtil.toString(whole + (dec/100));
			if(nStr.slice(0, 1) == "-"){
				return "-"+CURRENCY+nStr.slice(1);
			} else {
				return CURRENCY+nStr;
			}
		}
		
		public static function toString(n:Number, length:Number = 2):String{
			var nStr:String = Math.abs(n).toFixed(length);
			var pos:Number = nStr.indexOf(".")-3;
			while(pos>0){
				nStr = nStr.slice(0, pos)+","+nStr.slice(pos);
				pos-=3;
			}
			if(n<0){
				nStr = "-"+nStr;
			}
			return nStr;
		}
		public static function roundUp(n:Number, base:Number):Number{
			return Math.ceil(n/base)*base;
		}
		public static function roundDown(n:Number, base:Number):Number{
			return Math.floor(n/base)*base;
		}
		public static function min(...rest):Number{
			var minNum:Number = 0;
			for(var i:int =0; i<rest.length; i++){
				minNum = Math.min(minNum, rest[i]);
			}
			return minNum;
		}
		public static function max(...rest):Number{
			var maxNum:Number = 0;
			for(var i:int =0; i<rest.length; i++){
				maxNum = Math.max(maxNum, rest[i]);
			}
			return maxNum;
		}
		public static function shorthand(n:Number):String{
			var value:Number = Math.abs(n);
			var prefix:String = ((n<0)?"-":"");
			if(value<9){
				return prefix+CURRENCY+roundDown(value,1).toString();
			} else if(value<99){
				return prefix+CURRENCY+roundDown(value,10).toString();
			} else if(value<999){
				return prefix+CURRENCY+roundDown(value,100).toString();
			} else if(value<999999){
				return prefix+int(value/1000).toString()+"K";
			} else if(value<999999999){
				return prefix+(value/1000000).toFixed(1)+"M";
			} else {
				return prefix+(value/1000000000).toFixed(1)+"B";
			} 
		}
	}
}